<?php
/***************************************************************************
 *                            admin_games.php
 *                            ---------------
 *	begin				: 04/02/05
 *	copyright			: Mothieu
 *	email				: webmaster@onsbende.be
 *
 *	version			: v1.0.1 - 04/02/05
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', 1);
define('IN_GAMES_MOD', 1);

if( !empty($setmodules) )
{
	$file = basename(__FILE__);
	$module['Games_Admin']['Games_Edit_Auth'] = "$file?mode=editauth";
	$module['Games_Admin']['Games_Edit_Ranks'] = "$file?mode=editranks";
	$module['Games_Admin']['Games_Edit_Config'] = "$file";
	return;
}

//
// Load default header
//
$phpbb_root_path = "./../";
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);

if( isset($HTTP_GET_VARS['mode']) || isset($HTTP_POST_VARS['mode']) )
{
	$mode = ( isset($HTTP_GET_VARS['mode']) ) ? $HTTP_GET_VARS['mode'] : $HTTP_POST_VARS['mode'];
	$mode = htmlspecialchars($mode);
}
else 
{
	$mode = "";
}
if( isset($HTTP_POST_VARS['rank_act']) )
{
	$rank_act = $HTTP_POST_VARS['rank_act'];
	$rank_act = htmlspecialchars($rank_act);
}
else 
{
	$rank_act = "";
}

switch( $mode )
{
	//
	//===========================[ EDIT GAMES AUTHORISATION ]=======================
	//
	case "editauth":

		$template->set_filenames(array(
			"body" => "admin/games_edit_auth_body.tpl")
		);

		//
		// Pull all auth data
		//
		$sql = "SELECT * 
			FROM " . CONFIG_TABLE . " 
			WHERE config_name = 'games_auth_mode'";
		if(!$result = $db->sql_query($sql))
		{
			message_die(CRITICAL_ERROR, "Could not get games permissions information", "", __LINE__, __FILE__, $sql);
		}
		$sql = array();
		$row = $db->sql_fetchrow($result);
		if ( $row['config_name'] == 'games_auth_mode' )
		{
			$config_name = $row['config_name'];
			$default_auth_mode = $row['config_value'];
			$new_auth_mode = ( isset($HTTP_POST_VARS['games_auth_mode']) ) ? $HTTP_POST_VARS['games_auth_mode'] : $default_auth_mode;
			if( isset($HTTP_POST_VARS['submit']) )
			{
				$sql[] = "UPDATE " . CONFIG_TABLE . " SET
					config_value = '" . str_replace("\'", "''", $new_auth_mode) . "'
					WHERE config_name = 'games_auth_mode'";
			}
		}
		$sql_groups = "SELECT group_id, group_name, group_auth_games 
			FROM " . GROUPS_TABLE . " 
			WHERE group_single_user <> " . TRUE . " 
			ORDER BY group_name";
		if(!$result = $db->sql_query($sql_groups))
		{
			message_die(CRITICAL_ERROR, "Could not get groups information", "", __LINE__, __FILE__, $sql);
		}
		while( $row = $db->sql_fetchrow($result) )
		{
			$group_id = $row['group_id'];
			$group_name = $row['group_name'];
			$group_auth_yes = ( $row['group_auth_games'] ) ? "checked=\"checked\"" : "";
			$group_auth_no = ( !$row['group_auth_games'] ) ? "checked=\"checked\"" : "";
			$group_radio_name = "group" . $row['group_id'];
			$group_auth_mod_yes = ( $row['group_auth_mod_games'] ) ? "checked=\"checked\"" : "";
			$group_auth_mod_no = ( !$row['group_auth_mod_games'] ) ? "checked=\"checked\"" : "";
			$group_mod_radio_name = "mod_group" . $row['group_id'];
			$template->assign_block_vars('auth_groups', array(
				'GROUP_NAME' => $group_name,
				'RADIO_NAME' => $group_radio_name,
				'GROUP_AUTH_YES' => $group_auth_yes,
				'GROUP_AUTH_NO' => $group_auth_no,
				)
			);
			if( isset($HTTP_POST_VARS['submit']) && isset($HTTP_POST_VARS[$group_radio_name]) )
			{
				if ( $new_auth_mode == '2' )
				{
					$group_auth = $HTTP_POST_VARS[$group_radio_name];
					$sql[] = "UPDATE " . GROUPS_TABLE . " SET 
						group_auth_games = " . $group_auth . " 
						WHERE group_id = " . $group_id;
				}
				else
				{
					$sql[] = "UPDATE " . GROUPS_TABLE . " SET 
						group_auth_games = '0' 
						WHERE group_id = " . $group_id;
				}
			}
			$template->assign_block_vars('auth_mod_groups', array(
				'GROUP_NAME' => $group_name,
				'RADIO_NAME' => $group_mod_radio_name,
				'GROUP_AUTH_YES' => $group_auth_mod_yes,
				'GROUP_AUTH_NO' => $group_auth_mod_no,
				)
			);
			if( isset($HTTP_POST_VARS['submit']) && isset($HTTP_POST_VARS[$group_mod_radio_name]) )
			{
				$group_auth_mod = $HTTP_POST_VARS[$group_mod_radio_name];
				$sql[] = "UPDATE " . GROUPS_TABLE . " SET 
					group_auth_mod_games = " . $group_auth_mod . " 
					WHERE group_id = " . $group_id;
			}
		}
		if ( count($sql) != 0 )
		{
			for( $i = 0; $i < count($sql); $i++ )
			{
				if ( !($db->sql_query($sql[$i])) )
				{
					message_die(CRITICAL_ERROR, "Could not update permissions", "", __LINE__, __FILE__, $sql);
				}
			}
		}
		if( isset($HTTP_POST_VARS['submit']) )
		{
			$message = $lang['Games_General_Settings_Updated'] . "<br /><br />" . sprintf($lang['Click_Return_Games_General_Settings'], "<a href=\"" . append_sid("admin_games." . $phpEx) . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");
			message_die(GENERAL_MESSAGE, $message);
		}
		$games_auth_mode_none = ( $new_auth_mode == '0') ? "checked=\"checked\"" : "";
		$games_auth_mode_all = ( $new_auth_mode == '1' ) ? "checked=\"checked\"" : "";
		$games_auth_mode_groups = ( $new_auth_mode == '2') ? "checked=\"checked\"" : "";
		$s_hidden_fields = '<input type="hidden" name="mode" value="' . $mode . '" />';
		$template->assign_vars(array(
			"L_AUTH_TITLE" => $lang['Games_Auth'],
			"L_AUTH_EXPLAIN" => $lang['Games_Auth_Explain'],
			"L_AUTH_SETTINGS" => $lang['Games_Auth_Settings'],
			"L_AUTH_MODE" => $lang['Games_Auth_Mode'],
			"L_AUTH_MODE_EXPLAIN" => $lang['Games_Auth_Mode_Explain'],
			"L_AUTH_MODE_NONE" => $lang['Games_Auth_Mode_None'],
			"L_AUTH_MODE_ALL" => $lang['Games_Auth_Mode_All'],
			"L_AUTH_MODE_GROUPS" => $lang['Games_Auth_Mode_Groups'],
			"L_AUTH_GROUPS" => $lang['Games_Auth_Groups'],
			"L_AUTH_GROUPS_EXPLAIN" => $lang['Games_Auth_Groups_Explain'],
			"L_AUTH_MOD_GROUPS" => $lang['Games_Auth_Mod_Groups'],
			"L_AUTH_MOD_GROUPS_EXPLAIN" => $lang['Games_Auth_Mod_Groups_Explain'],
			"L_SUBMIT" => $lang['Submit'],
			"L_RESET" => $lang['Reset'],
			'L_YES' => $lang['Yes'],
			'L_NO' => $lang['No'],
			"AUTH_MODE_NONE" => $games_auth_mode_none,
			"AUTH_MODE_ALL" => $games_auth_mode_all,
			"AUTH_MODE_GROUPS" => $games_auth_mode_groups,
			"S_AUTH_ACTION" => append_sid("admin_games." . $phpEx),
			"S_HIDDEN_FIELDS" => $s_hidden_fields
			)
		);
		$template->pparse("body");
	break;

	//
	//===========================[ EDIT GAMES RANKS ]===============================
	//
	case "editranks":
		if( $rank_act == "edit_rank" || $rank_act == "add_rank" || $rank_act == "save_rank" || $rank_act == "delete_rank" )
		{
			if( $rank_act == "edit_rank" || $rank_act == "add_rank" )
			{
				//
				// They want to add/edit a rank, show the form.
				//
				$rank_id = ( isset($HTTP_GET_VARS['rank_id']) ) ? intval($HTTP_GET_VARS['rank_id']) : 0;
				$s_hidden_fields = "";
				if( $rank_act == "edit_rank" )
				{
					if( empty($rank_id) )
					{
						message_die(GENERAL_MESSAGE, $lang['Must_select_rank']);
					}
					$sql = "SELECT * FROM " . GAMES_RANKS_TABLE . " 
						WHERE rank_id = " . $rank_id;
					if(!$result = $db->sql_query($sql))
					{
						message_die(GENERAL_ERROR, "Couldn't obtain games rank data", "", __LINE__, __FILE__, $sql);
					}
					$rank_info = $db->sql_fetchrow($result);
					$s_hidden_fields .= '<input type="hidden" name="rank_id" value="' . $rank_id . '" />';
				}
				$s_hidden_fields .= '<input type="hidden" name="mode" value="' . $mode . '" />';
				$s_hidden_fields .= '<input type="hidden" name="rank_act" value="save_rank" />';
				$template->set_filenames(array(
					"body" => "admin/games_edit_ranks_body.tpl")
				);
				$template->assign_vars(array(
					"L_RANKS_TITLE" => $lang['Games_Ranks_Title'],
					"L_RANKS_EXPLAIN" => $lang['Games_Ranks_Explain'],
					"L_RANK_TITLE" => $lang['Rank_title'],
					"L_RANK_MINIMUM" => $lang['Games_Rank_Minimum'],
					"L_SUBMIT" => $lang['Submit'],
					"L_RESET" => $lang['Reset'],
					"L_YES" => $lang['Yes'],
					"L_NO" => $lang['No'],
					"RANK" => $rank_info['rank_title'],
					"MINIMUM" => $rank_info['rank_min'],
					"S_RANK_ACTION" => append_sid("admin_games.$phpEx?mode=editranks"),
					"S_HIDDEN_FIELDS" => $s_hidden_fields)
				);
			}
			else if( $rank_act == "save_rank" )
			{
				//
				// Ok, they sent us our info, let's update it.
				//
				$rank_id = ( isset($HTTP_POST_VARS['rank_id']) ) ? intval($HTTP_POST_VARS['rank_id']) : 0;
				$rank_title = ( isset($HTTP_POST_VARS['title']) ) ? trim($HTTP_POST_VARS['title']) : "";
				$min_points = ( isset($HTTP_POST_VARS['min_points']) ) ? intval($HTTP_POST_VARS['min_points']) : 0;
				if( $rank_title == "" )
				{
					message_die(GENERAL_MESSAGE, $lang['Games_Must_Enter_Rank_Title']);
				}
				if ($rank_id)
				{
					$sql = "UPDATE " . GAMES_RANKS_TABLE . "
						SET rank_title = '" . str_replace("\'", "''", $rank_title) . "', rank_min = " . $min_points . " 
						WHERE rank_id = $rank_id";
					$message = $lang['Games_Rank_Updated'];
				}
				else
				{
					$sql = "INSERT INTO " . RANKS_TABLE . " (rank_title, rank_min)
						VALUES ('" . str_replace("\'", "''", $rank_title) . "', $min_points)";
					$message = $lang['Games_Rank_Added'];
				}
				if( !$result = $db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, "Couldn't update/insert into games ranks table", "", __LINE__, __FILE__, $sql);
				}
				$message .= "<br /><br />" . sprintf($lang['Click_Return_Games_Ranks_Admin'], "<a href=\"" . append_sid("admin_games.$phpEx?mode=editranks") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");
				message_die(GENERAL_MESSAGE, $message);
			}
			else if( $rank_act == "delete_rank" )
			{
				//
				// Ok, they want to delete their rank
				//
				if( isset($HTTP_POST_VARS['rank_id']) || isset($HTTP_GET_VARS['rank_id']) )
				{
					$rank_id = ( isset($HTTP_POST_VARS['rank_id']) ) ? intval($HTTP_POST_VARS['rank_id']) : intval($HTTP_GET_VARS['rank_id']);
				}
				else
				{
					$rank_id = 0;
				}
				if( $rank_id )
				{
					$sql = "DELETE FROM " . GAMES_RANKS_TABLE . "
						WHERE rank_id = $rank_id";
					if( !$result = $db->sql_query($sql) )
					{
						message_die(GENERAL_ERROR, "Couldn't delete games rank data", "", __LINE__, __FILE__, $sql);
					}
					$message = $lang['Games_Rank_Removed'] . "<br /><br />" . sprintf($lang['Click_Return_Games_Rank_Admin'], "<a href=\"" . append_sid("admin_games.$phpEx?mode=editranks") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");
					message_die(GENERAL_MESSAGE, $message);
				}
				else
				{
					message_die(GENERAL_MESSAGE, $lang['Must_select_rank']);
				}
			}
		}
		else
		{
			//
			// Show the default games ranks page
			//
			$template->set_filenames(array(
				"body" => "admin/games_list_ranks_body.tpl")
			);
			$sql = "SELECT * FROM " . GAMES_RANKS_TABLE . "
				ORDER BY rank_min ASC";
			if( !$result = $db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, "Couldn't obtain games ranks data", "", __LINE__, __FILE__, $sql);
			}
			else
			{
				$rank_count = $db->sql_numrows($result);
				$rank_rows = $db->sql_fetchrowset($result);
				$s_hidden_fields = '<input type="hidden" name="mode" value="' . $mode . '" />';
			}
			$template->assign_vars(array(
				"L_RANKS_TITLE" => $lang['Games_Ranks_Title'],
				"L_RANKS_EXPLAIN" => $lang['Games_Ranks_Explain'],
				"L_RANK" => $lang['Rank_title'],
				"L_RANK_MINIMUM" => $lang['Games_Rank_Minimum'],
				"L_EDIT" => $lang['Edit'],
				"L_DELETE" => $lang['Delete'],
				"L_ADD_RANK" => $lang['Add_new_rank'],
				"S_HIDDEN_FIELDS" => $s_hidden_fields,
				"S_RANKS_ACTION" => append_sid("admin_games.$phpEx?mode=editranks"))
			);
			for($i = 0; $i < $rank_count; $i++)
			{
				$rank = $rank_rows[$i]['rank_title'];
				$rank_id = $rank_rows[$i]['rank_id'];
				$rank_min = $rank_rows[$i]['rank_min'];
				$row_color = ( !($i % 2) ) ? $theme['td_color1'] : $theme['td_color2'];
				$row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];
				$template->assign_block_vars("ranks", array(
					"ROW_COLOR" => "#" . $row_color,
					"ROW_CLASS" => $row_class,
					"RANK" => $rank,
					"RANK_MIN" => $rank_min,
					"U_RANK_EDIT" => append_sid("admin_games.$phpEx?mode=editranks&amp;rank_act=edit_rank&amp;rank_id=$rank_id"),
					"U_RANK_DELETE" => append_sid("admin_games.$phpEx?mode=editranks&amp;rank_act=delete_rank&amp;rank_id=$rank_id"))
				);
			}
		}
		$template->pparse("body");
	break;

	//
	//===========================[ EDIT GAMES CONFIG ]==============================
	//
	default:

		//
		// Pull all config data
		//
		$sql = "SELECT * 
			FROM " . CONFIG_TABLE . " 
			WHERE config_name = 'games_win_lost_percentage' 
				OR config_name = 'games_minimum' 
				OR config_name = 'games_max_challenges'";
		if(!$result = $db->sql_query($sql))
		{
			message_die(CRITICAL_ERROR, "Could not get games config information", "", __LINE__, __FILE__, $sql);
		}
		else
		{
			$sql = array();
			while( $row = $db->sql_fetchrow($result) )
			{
				$config_name = $row['config_name'];
				$config_value = $row['config_value'];
				$default_config[$config_name] = $config_value;
				$new[$config_name] = ( isset($HTTP_POST_VARS[$config_name]) ) ? $HTTP_POST_VARS[$config_name] : $default_config[$config_name];
				if( isset($HTTP_POST_VARS['submit']) )
				{
					$sql[] = "UPDATE " . CONFIG_TABLE . " SET
						config_value = '" . str_replace("\'", "''", $new[$config_name]) . "'
						WHERE config_name = '$config_name'";
				}
			}
			if( isset($HTTP_POST_VARS['submit']) )
			{
				if ( $new['games_minimum'] != $default_config['games_minimum'] )
				{
					$newdefault = $new['games_minimum'];
					$sql[] = "UPDATE " . USERS_TABLE . " SET
						games_points = '" . str_replace("\'", "''", $newdefault) . "'
						WHERE games_points < " . $newdefault;
					$sql[] = "ALTER TABLE " . USERS_TABLE . " ALTER games_points SET DEFAULT " . $newdefault;
				}
			}
			for( $i = 0; $i < count($sql); $i++ )
			{
				if ( !($db->sql_query($sql[$i])) )
				{
					message_die(CRITICAL_ERROR, "Could not update games configuration", "", __LINE__, __FILE__, $sql);
				}
			}
			if( isset($HTTP_POST_VARS['submit']) )
			{
				$message = $lang['Games_General_Settings_Updated'] . "<br /><br />" . sprintf($lang['Click_Return_Games_General_Settings'], "<a href=\"" . append_sid("admin_games." . $phpEx) . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");
				message_die(GENERAL_MESSAGE, $message);
			}
		}
		$s_hidden_fields = '<input type="hidden" name="mode" value="' . $mode . '" />';
		$template->set_filenames(array(
			"body" => "admin/games_edit_config_body.tpl")
		);
		$template->assign_vars(array(
			"L_CONFIG_TITLE" => $lang['Games_Config'],
			"L_CONFIG_EXPLAIN" => $lang['Games_Config_Explain'],
			"L_SETTINGS" => $lang['Games_General_Settings'],
			"L_WIN_LOST_PERCENTAGE" => $lang['Games_Win_Lost_Percentage'],
			"L_WIN_LOST_PERCENTAGE_EXPLAIN" => $lang['Games_Win_Lost_Percentage_Explain'],
			"L_MINIMUM" => $lang['Games_Minimum'],
			"L_MINIMUM_EXPLAIN" => $lang['Games_Minimum_Explain'],
			"L_MAX_CHALLENGES" => $lang['Games_Max_Challenges'],
			"L_MAX_CHALLENGES_EXPLAIN" => $lang['Games_Max_Challenges_Explain'],

			"L_SUBMIT" => $lang['Submit'], 
			"L_RESET" => $lang['Reset'], 

			"WIN_LOST_PERCENTAGE" => $new['games_win_lost_percentage'], 
			"MINIMUM" => $new['games_minimum'], 
			"MAX_CHALLENGES" => $new['games_max_challenges'], 

			"S_CONFIG_ACTION" => append_sid("admin_games." . $phpEx), 
			"S_HIDDEN_FIELDS" => $s_hidden_fields 
			)
		);
		$template->pparse("body");
	break;
}

include('./page_footer_admin.'.$phpEx);

?>