<?php
/***************************************************************************
 *                            functions_games_mod.php
 *                            -----------------------
 *	begin				: 04/02/05
 *	copyright			: Mothieu
 *	email				: webmaster@onsbende.be
 *
 *	version			: v1.0.1 - 04/02/05
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if (!defined('IN_PHPBB'))
{
	die('Hacking attempt');
}

//
// Get registered users, by specific order
//
function get_users_ids($order_by)
{
	global $db;
	$sql = "SELECT user_id 
		FROM " . USERS_TABLE . "
		WHERE user_id != " . ANONYMOUS . "
		ORDER BY " . $order_by;
	if ( $result = $db->sql_query($sql) )
	{
		$auth_users_ids = array();
		while ( $row = $db->sql_fetchrow($result) )
		{
			$auth_users_ids[] = $row['user_id'];
		}
	}
	else
	{
		message_die(GENERAL_MESSAGE, "Problems getting users out of database" );
	}
	return $auth_users_ids;
}

//
// Get next game id
//
function get_next_game_id()
{
	global $db;
	$sql = "SELECT COUNT(game_id) AS total
		FROM " . GAMES_TABLE;
	if ( $result = $db->sql_query($sql) )
	{
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
		$game_id = $row['total'] + 1;
	}
	else
	{
		message_die(GENERAL_ERROR, "Could not obtain games-information" );
	}
	return $game_id;
}

//
// Get games-rank of a user
//
function get_games_rank($games_points)
{
	global $db;
	$sql = "SELECT * 
		FROM " . GAMES_RANKS_TABLE . " 
		ORDER BY rank_min ASC";
	$rank = "";
	if ( $result = $db->sql_query($sql) )
	{
		$i = 0;
		while ( $row = $db->sql_fetchrow($result) )
		{
			if ( $games_points >= $row['rank_min'] )
			{
				$rank = $row['rank_title'];
			}
		}
		$db->sql_freeresult($result);
	}
	return $rank;
}

//
// Get games points of a user
//
function get_games_user_points($user_id)
{
	global $db;
	$sql = "SELECT games_points 
		FROM " . USERS_TABLE . " 
		WHERE user_id = " . $user_id;
	if ( $result = $db->sql_query($sql) )
	{
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
		$games_user_points = $row['games_points'];
	}
	return $games_user_points;
}

//
// Get the username of a user
//
function get_games_username($user_id)
{
	global $db;
	$sql = "SELECT username 
		FROM " . USERS_TABLE . " 
		WHERE user_id = " . $user_id;
	if ( $result = $db->sql_query($sql) )
	{
		$temp_username = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
		$games_username = $temp_username['username'];
	}
	return $games_username;
}

//
// Get the id of a user
//
function get_games_user_id($username)
{
	global $db;
	$sql = "SELECT user_id 
		FROM " . USERS_TABLE . " 
		WHERE username = " . $username;
	if ( $result = $db->sql_query($sql) )
	{
		$temp_id = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
		$user_id = $temp_id['user_id'];
	}
	else
	{
		$user_id = '-2';
	}
	return $user_id;
}

//
// Check if a user is ingame or not
//
function check_ingame($user_id)
{
	global $db, $lang;
	$sql = "SELECT games_current_game 
		FROM " . USERS_TABLE . " 
		WHERE user_id = " . $user_id;
	if ( $result = $db->sql_query($sql) )
	{
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
		$current_game = $row['games_current_game'];
		if ( $current_game != '-1' )
		{
			message_die(GENERAL_MESSAGE, $lang['Games_Self_Ingame']);
		}
	}
	return;
}

//
// Define a post as an automatic generated post
//
function make_post_autom($post_id)
{
	global $db;
	$sql = "UPDATE " . POSTS_TABLE . " 
		SET games_autom_post = 1 
		WHERE post_id = " . $post_id;
	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Error in posting', '', __LINE__, __FILE__, $sql);
	}
	return;
}

//
// Prepare a message for posting a new game
// 
function prepare_new_game(&$post_data, &$bbcode_on, &$html_on, &$smilies_on, &$error_msg, &$username, &$opponent_name, &$opponent_id, &$bbcode_uid, &$subject, &$message, &$poll_title, &$poll_options, &$poll_length)
{
	global $db, $board_config, $userdata, $lang, $phpEx, $phpbb_root_path;

	// Check username
	$username = trim(strip_tags($username));
	$opponent_name = trim(strip_tags($opponent_name));

	// Check subject
	$subject = htmlspecialchars(trim($subject));

	// Check message
	if (!empty($message))
	{
		$bbcode_uid = ($bbcode_on) ? make_bbcode_uid() : '';
		$message = prepare_message(trim($message), $html_on, $bbcode_on, $smilies_on, $bbcode_uid);
	}
	else
	{
		$error_msg .= (!empty($error_msg)) ? '<br />' . $lang['Games_Empty_Message'] : $lang['Games_Empty_Message'];
	}

	// Check if opponent is still avaible for gaming
	if (!empty($opponent_id))
	{
		$sql = "SELECT games_current_game
			FROM " . USERS_TABLE . " 
			WHERE user_id = " . $opponent_id;
		if ( $result = $db->sql_query($sql) )
		{
			$row = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);
			$opponent_current_game = $row['games_current_game'];
			if ( $opponent_current_game != "-1")
			{
				message_die(GENERAL_MESSAGE, $lang['Games_Opponent_Not_Possible']);
			}		
		}
		else
		{
			message_die(GENERAL_MESSAGE, $lang['Games_Opponent_Deleted']);
		}
	}
	else
	{
		$error_msg .= (!empty($error_msg)) ? '<br />' . $lang['Games_Empty_Opponent'] : $lang['Games_Empty_Opponent'];
	}

	//
	// Handle poll stuff
	//
	$poll_title = htmlspecialchars(trim($poll_title));

	$temp_option_text = array();
	while(list($option_id, $option_text) = @each($poll_options))
	{
		$option_text = trim($option_text);
		if (!empty($option_text))
		{
			$temp_option_text[$option_id] = htmlspecialchars($option_text);
		}
	}
	$option_text = $temp_option_text;
	return;
}

//
// Post a new game (=newtopic)
//
function submit_new_game(&$post_data, &$message, &$meta, &$forum_id, &$topic_id, &$post_id, &$poll_id, &$topic_type, &$bbcode_on, &$html_on, &$smilies_on, &$attach_sig, &$bbcode_uid, &$post_username1, &$post_user_id1, &$post_points_before, &$post_username2, &$post_user_id2, &$post_points_before2, &$post_subject, &$post_message, &$poll_title, &$poll_options, &$poll_length)
{
	global $board_config, $lang, $db, $phpbb_root_path, $phpEx;
	global $userdata, $user_ip;

	include($phpbb_root_path . 'includes/functions_search.'.$phpEx);

	$current_time = time();

	//
	// Flood control
	//
	$sql = "SELECT MAX(post_time) AS last_post_time
		FROM " . POSTS_TABLE . " 
		WHERE poster_id = " . $userdata['user_id'];
	if ($result = $db->sql_query($sql))
	{
		if ($row = $db->sql_fetchrow($result))
		{
			if (intval($row['last_post_time']) > 0 && ($current_time - intval($row['last_post_time'])) < intval($board_config['flood_interval']))
			{
				message_die(GENERAL_MESSAGE, $lang['Flood_Error']);
			}
		}
	}

	//
	// Add post
	//
	$topic_vote = 1;
	$sql  = "INSERT INTO " . TOPICS_TABLE . " (topic_title, topic_poster, topic_time, forum_id, topic_status, topic_type, topic_vote) VALUES ('$post_subject', " . $userdata['user_id'] . ", $current_time, $forum_id, " . TOPIC_UNLOCKED . ", $topic_type, $topic_vote)";
	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Error in posting', '', __LINE__, __FILE__, $sql);
	}

	$topic_id = $db->sql_nextid();

	$sql = "INSERT INTO " . POSTS_TABLE . " (topic_id, forum_id, poster_id, post_username, post_time, poster_ip, enable_bbcode, enable_html, enable_smilies, enable_sig) VALUES ($topic_id, $forum_id, " . $userdata['user_id'] . ", '$post_username1', $current_time, '$user_ip', $bbcode_on, $html_on, $smilies_on, $attach_sig)";
	if (!$db->sql_query($sql, BEGIN_TRANSACTION))
	{
		message_die(GENERAL_ERROR, 'Error in posting', '', __LINE__, __FILE__, $sql);
	}

	$post_id = $db->sql_nextid();

	$sql = "INSERT INTO " . POSTS_TEXT_TABLE . " (post_id, post_subject, bbcode_uid, post_text) VALUES ($post_id, '$post_subject', '$bbcode_uid', '$post_message')";
	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Error in posting', '', __LINE__, __FILE__, $sql);
	}

	add_search_words('single', $post_id, stripslashes($post_message), stripslashes($post_subject));

	//
	// Add poll
	// 
	$sql = "INSERT INTO " . VOTE_DESC_TABLE . " (topic_id, vote_text, vote_start, vote_length) VALUES ($topic_id, '$poll_title', $current_time, " . ($poll_length * 86400) . ")";
	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Error in posting', '', __LINE__, __FILE__, $sql);
	}

	$poll_id = $db->sql_nextid();

	@reset($poll_options);

	$poll_option_id = 1;
	while (list($option_id, $option_text) = each($poll_options))
	{
		if (!empty($option_text))
		{
			$option_text = str_replace("\'", "''", htmlspecialchars($option_text));
			$poll_result = 0;

			$sql = "INSERT INTO " . VOTE_RESULTS_TABLE . " (vote_id, vote_option_id, vote_option_text, vote_result) VALUES ($poll_id, $poll_option_id, '$option_text', $poll_result)";
			if (!$db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Error in posting', '', __LINE__, __FILE__, $sql);
			}
			$poll_option_id++;
		}
	}

	$meta = '<meta http-equiv="refresh" content="3;url=' . append_sid("viewtopic.$phpEx?" . POST_POST_URL . "=" . $post_id) . '#' . $post_id . '">';
	$message = $lang['Games_Stored'] . '<br /><br />' . sprintf($lang['Games_Click_View_Game'], '<a href="' . append_sid("viewtopic.$phpEx?" . POST_POST_URL . "=" . $post_id) . '#' . $post_id . '">', '</a>') . '<br /><br />' . sprintf($lang['Games_Click_Return_Running_Games'], '<a href="' . append_sid("games.$phpEx?mode=running") . '">', '</a>');

	//
	// Add game in games table
	//
	$sql = "INSERT INTO " . GAMES_TABLE . " (topic_id, games_first_post_id, game_date, player_id, player_b_id, player_points_before, player_b_points_before) VALUES ($topic_id, $post_id, $current_time, $post_user_id1, $post_user_id2, $post_points_before, $post_points_before2)";
	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Error in posting', '', __LINE__, __FILE__, $sql);

	}
	$games_id = $db->sql_nextid();

	//
	// Add in both users their current game in users table
	//
	$sql = "UPDATE " . USERS_TABLE . " SET games_current_game = " . $games_id . " WHERE user_id = " . $post_user_id1 . " OR user_id = " . $post_user_id2;
	if (!$db->sql_query($sql))
	{
		message_die(GENERAL_ERROR, 'Error in posting', '', __LINE__, __FILE__, $sql);
	}
	return false;
}

//
// This function makes a new PM for the opponent and mails him to notify him of it
//
function notify_opponent(&$to_username)
{
	global $board_config, $lang, $db, $phpbb_root_path, $phpEx;
	global $userdata, $user_ip;

	if ( $userdata['user_allow_pm'] && empty($board_config['privmsg_disable']) )
	{
		//
		// Settings for PM
		//
		$html_on = 0;
		$bbcode_on = TRUE;
		$smilies_on = 0;
		$attach_sig = 0;
		$user_sig = "";

		$sql = "SELECT user_id, user_notify_pm, user_email, user_lang, user_active 
			FROM " . USERS_TABLE . "
			WHERE username = '" . str_replace("\'", "''", $to_username) . "' 
			AND user_id <> " . ANONYMOUS;
		$result = $db->sql_query($sql);
		$to_userdata = $db->sql_fetchrow($result);

		$privmsg_subject = "New Challenge";
		if ( $bbcode_on )
		{
			$bbcode_uid = make_bbcode_uid();
		}
		$privmsg_message = $userdata['username'];
		$privmsg_message .= $lang['Games_Challenged_You_For_Game'];
		$privmsg_message .= "\n\r" . sprintf($lang['Games_Click_Return_Running_Games'], '[url=' . append_sid("games.$phpEx?mode=running") . ']', '[/url]');
		$privmsg_message = prepare_message($privmsg_message, $html_on, $bbcode_on, $smilies_on, $bbcode_uid);

		$msg_time = time();
		//
		// See if recipient is at their inbox limit
		//
		$sql = "SELECT COUNT(privmsgs_id) AS inbox_items, MIN(privmsgs_date) AS oldest_post_time 
			FROM " . PRIVMSGS_TABLE . " 
			WHERE ( privmsgs_type = " . PRIVMSGS_NEW_MAIL . " 
					OR privmsgs_type = " . PRIVMSGS_READ_MAIL . "  
					OR privmsgs_type = " . PRIVMSGS_UNREAD_MAIL . " ) 
				AND privmsgs_to_userid = " . $to_userdata['user_id'];
		$result = $db->sql_query($sql);
		$sql_priority = ( SQL_LAYER == 'mysql' ) ? 'LOW_PRIORITY' : '';
		if ( $inbox_info = $db->sql_fetchrow($result) )
		{
			if ( $inbox_info['inbox_items'] >= $board_config['max_inbox_privmsgs'] )
			{
				$sql = "SELECT privmsgs_id FROM " . PRIVMSGS_TABLE . " 
					WHERE ( privmsgs_type = " . PRIVMSGS_NEW_MAIL . " 
							OR privmsgs_type = " . PRIVMSGS_READ_MAIL . " 
							OR privmsgs_type = " . PRIVMSGS_UNREAD_MAIL . "  ) 
						AND privmsgs_date = " . $inbox_info['oldest_post_time'] . " 
						AND privmsgs_to_userid = " . $to_userdata['user_id'];
				$result = $db->sql_query($sql);
				$old_privmsgs_id = $db->sql_fetchrow($result);
				$old_privmsgs_id = $old_privmsgs_id['privmsgs_id'];
				$sql = "DELETE $sql_priority FROM " . PRIVMSGS_TABLE . " 
					WHERE privmsgs_id = $old_privmsgs_id";
				$db->sql_query($sql);
				$sql = "DELETE $sql_priority FROM " . PRIVMSGS_TEXT_TABLE . " 
					WHERE privmsgs_text_id = $old_privmsgs_id";
				$db->sql_query($sql);
			}
		}
		$sql_info = "INSERT INTO " . PRIVMSGS_TABLE . " (privmsgs_type, privmsgs_subject, privmsgs_from_userid, privmsgs_to_userid, privmsgs_date, privmsgs_ip, privmsgs_enable_html, privmsgs_enable_bbcode, privmsgs_enable_smilies, privmsgs_attach_sig)
			VALUES (" . PRIVMSGS_NEW_MAIL . ", '" . str_replace("\'", "''", $privmsg_subject) . "', " . $userdata['user_id'] . ", " . $to_userdata['user_id'] . ", $msg_time, '$user_ip', $html_on, $bbcode_on, $smilies_on, $attach_sig)";
		$db->sql_query($sql_info, BEGIN_TRANSACTION);
		$privmsg_sent_id = $db->sql_nextid();
		$sql = "INSERT INTO " . PRIVMSGS_TEXT_TABLE . " (privmsgs_text_id, privmsgs_bbcode_uid, privmsgs_text)
			VALUES ($privmsg_sent_id, '" . $bbcode_uid . "', '" . str_replace("\'", "''", $privmsg_message) . "')";
		$db->sql_query($sql, END_TRANSACTION);
		//
		// Add to the users new pm counter
		//
		$sql = "UPDATE " . USERS_TABLE . "
			SET user_new_privmsg = user_new_privmsg + 1, user_last_privmsg = " . time() . "  
			WHERE user_id = " . $to_userdata['user_id']; 
		$db->sql_query($sql);
		//
		// Notify user by email of his new PM
		//
		if ( $to_userdata['user_notify_pm'] && !empty($to_userdata['user_email']) && $to_userdata['user_active'] )
		{
			$script_name = preg_replace('/^\/?(.*?)\/?$/', "\\1", trim($board_config['script_path']));
			$script_name = ( $script_name != '' ) ? $script_name . '/privmsg.'.$phpEx : 'privmsg.'.$phpEx;
			$server_name = trim($board_config['server_name']);
			$server_protocol = ( $board_config['cookie_secure'] ) ? 'https://' : 'http://';
			$server_port = ( $board_config['server_port'] <> 80 ) ? ':' . trim($board_config['server_port']) . '/' : '/';
			include($phpbb_root_path . 'includes/emailer.'.$phpEx);
			$emailer = new emailer($board_config['smtp_delivery']);
			$emailer->from($board_config['board_email']);
			$emailer->replyto($board_config['board_email']);
			$emailer->use_template('privmsg_notify', $to_userdata['user_lang']);
			$emailer->email_address($to_userdata['user_email']);
			$emailer->set_subject($lang['Notification_subject']);
			$emailer->assign_vars(array(
				'USERNAME' => $to_username, 
				'SITENAME' => $board_config['sitename'],
				'EMAIL_SIG' => (!empty($board_config['board_email_sig'])) ? str_replace('<br />', "\n", "-- \n" . $board_config['board_email_sig']) : '', 
				'U_INBOX' => $server_protocol . $server_name . $server_port . $script_name . '?folder=inbox')
			);
			$emailer->send();
			$emailer->reset();
		}
	}
	return false;
}

//
// Get games statistics
//
function get_games_stats($sql_where, $sql_order, $sql_limit)
{
	global $db;
	$sql = "SELECT * 
		FROM " . USERS_TABLE . " 
		WHERE " . $sql_where . " 
		ORDER BY " . $sql_order . " 
		LIMIT 0, " . $sql_limit;
	$stats_info = array();
	if ( $result = $db->sql_query($sql) )
	{
		$auth_users_info = array();
		while ( $row = $db->sql_fetchrow($result) )
		{
			$stats_info[] = $row;
		}
		$db->sql_freeresult($result);
	}
	return $stats_info;
}

?>